core:module("CoreMenuInput")
core:import("CoreDebug")
core:import("CoreMenuItem")
core:import("CoreMenuItemSlider")
core:import("CoreMenuItemToggle")

function MenuInput:update(t, dt)
	self:_check_releases()
	self:any_keyboard_used()

	local axis_timer = self:axis_timer()

	if axis_timer.y > 0 then
		self:set_axis_y_timer(axis_timer.y - dt)
	end

	if axis_timer.x > 0 then
		self:set_axis_x_timer(axis_timer.x - dt)
	end

	if self:_input_hijacked() then
		local item = self._logic:selected_item()

		if item and item.INPUT_ON_HIJACK then
			self._item_input_action_map[item.TYPE](item, self._controller)
		end

		return false
	end

	if self._accept_input and self._controller then
		if axis_timer.y <= 0 then
			if self:menu_up_input_bool() then
				self:prev_item()
				self:set_axis_y_timer(0.12)

				if self:menu_up_pressed() then
					self:set_axis_y_timer(0.3)
				end
			elseif self:menu_down_input_bool() then
				self:next_item()
				self:set_axis_y_timer(0.12)

				if self:menu_down_pressed() then
					self:set_axis_y_timer(0.3)
				end
			end
		end

		if axis_timer.x <= 0 then
			local item = self._logic:selected_item()

			if item then
				self._item_input_action_map[item.TYPE](item, self._controller)
			end
		end

		if self._controller:get_input_pressed("menu_toggle_legends") and not managers.menu:is_pc_controller() then
			print("update something")
			self._logic:update_node()
		elseif self._controller:get_input_pressed("menu_update") and managers.menu:is_pc_controller() then
			self._logic:update_node()
		end

		if self._controller:get_input_pressed("menu_update") and not managers.menu:is_pc_controller() and managers.menu:active_menu().logic:selected_node():parameters().name == "fast_net" then
			managers.menu:open_node("crimenet_filters", {})
			managers.network.matchmake:load_user_filters()
		elseif self._controller:get_input_pressed("menu_toggle_filters") and managers.menu:is_pc_controller() and managers.menu:active_menu().logic:selected_node():parameters().name == "fast_net" then
			managers.menu:open_node("crimenet_filters", {})
			managers.network.matchmake:load_user_filters()
		end

		if self._controller:get_input_pressed("menu_respec_tree_all") and managers.menu:active_menu().logic:selected_node():parameters().name == "fast_net" then
				_G.FastNETMenu:Reconnect()
		end
	end

	return true
end